<?php

namespace Service\Integration;

class ChatGptIntegration {

    protected $urlChatGpt;

    protected $asActivatedChatGpt;


    public function __construct($urlChatGpt, $asActivatedChatGpt){
        $this->urlChatGpt = $urlChatGpt;
        $this->asActivatedChatGpt = $asActivatedChatGpt;
    }

    public function getAsActivatedChatGpt() {
        return $this->asActivatedChatGpt;
    }

    public function callAskIA($actionData)
    {
        $url = $this->urlChatGpt."/ask";
        return $this->requestChatGptIntegrationPost($url, $actionData);
    }

    /**
     * @param string $url
     * @param array $data
     * @return array
     */
    protected function requestChatGptIntegrationPost($url, $data)
    {
        $headers = [
            'Content-Type: application/json',
        ];

        $curl = curl_init();

        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_TIMEOUT, 86400);

        $result = curl_exec($curl);
        $httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $curlError = curl_error($curl);

        curl_close($curl);

        // Verifica se houve erro na execução do cURL
        if ($curlError) {
            return [
                'error' => true,
                'statusCode' => 0,
                'curlError' => $curlError,
            ];
        }

        // Retorna resposta formatada
        if ($httpCode >= 400) {
            return [
                'error' => true,
                'statusCode' => $httpCode,
                'response' => $result,
            ];
        }

        return [
            'error' => false,
            'statusCode' => $httpCode,
            'response' => json_decode($result, true),
        ];
    }

}
